VERSION 5.00
Begin VB.Form TestForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Test Gipals32.dll"
   ClientHeight    =   6975
   ClientLeft      =   6990
   ClientTop       =   5715
   ClientWidth     =   6705
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6975
   ScaleWidth      =   6705
   ShowInTaskbar   =   0   'False
   Begin VB.Frame Frame1 
      Caption         =   "Results"
      Height          =   3855
      Left            =   120
      TabIndex        =   9
      Top             =   3000
      Width           =   6495
      Begin VB.ListBox lbResults 
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   9
            Charset         =   204
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   3210
         ItemData        =   "GipalsTestVB.frx":0000
         Left            =   120
         List            =   "GipalsTestVB.frx":0002
         TabIndex        =   10
         Top             =   240
         Width           =   6255
      End
   End
   Begin VB.CommandButton btnTransport 
      Caption         =   "Test Transport Problem"
      Height          =   375
      Left            =   120
      TabIndex        =   8
      Top             =   2520
      Width           =   2655
   End
   Begin VB.FileListBox lstFile 
      Height          =   1845
      Left            =   4200
      Pattern         =   "*.mps"
      TabIndex        =   7
      Top             =   120
      Width           =   2415
   End
   Begin VB.DriveListBox cmbDrive 
      Height          =   315
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   3975
   End
   Begin VB.DirListBox lstDir 
      Height          =   1440
      Left            =   120
      TabIndex        =   5
      Top             =   480
      Width           =   3975
   End
   Begin VB.CommandButton btnLoadMPS 
      Caption         =   "Load and Calculate MPS"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   2040
      Width           =   2655
   End
   Begin VB.TextBox edtDualObj 
      Height          =   285
      Left            =   4920
      TabIndex        =   3
      Top             =   2520
      Width           =   1695
   End
   Begin VB.TextBox edtPrimalObj 
      Height          =   285
      Left            =   4920
      TabIndex        =   1
      Top             =   2160
      Width           =   1695
   End
   Begin VB.Label Label2 
      Caption         =   "Dual Objective:"
      Height          =   255
      Left            =   3480
      TabIndex        =   2
      Top             =   2520
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Primal Objective:"
      Height          =   255
      Left            =   3480
      TabIndex        =   0
      Top             =   2160
      Width           =   1335
   End
End
Attribute VB_Name = "TestForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Header unit for Gipals32.dll.
'
' There are two possible ways to work with the library Gipals32.dll.
'
' 1) First way is a linear program construction by the provided set of functions,
'    such as specification of the variables and constraints count and assignment
'    of the constraint matrix elements. This way provides a complete flexibility
'    of the linear programming modeling.
'
' 2) The second way is importing linear program from a text file in MPS format.
'    It can be done by one function LoadFromMPS. This way can be suitable if there
'    is a set of prepared MPS files that need to be calculated.
'
'
'   Optimalon Software, 2005
'

' Constraint sign
  Const sign_Less   As Integer = 0 ' <=
  Const sign_Equal As Integer = 1  ' =
  Const sign_More   As Integer = 2 ' >=

' Preprocessor flags
  Const prep_Disable           As Integer = 0  ' Disable preprocessor
  Const prep_RemoveFixedVars   As Integer = 1  ' Remove all fixed variables
  Const prep_RemoveEmptyCols   As Integer = 2  ' Remove empty columns
  Const prep_RemoveSingular    As Integer = 4  ' Remove singular rows and columns
  Const prep_RemoveLinearRows  As Integer = 8   ' Remove linear-dependent rows
  Const prep_RemoveLinearCols  As Integer = 16  ' Remove linear-dependent columns
  Const prep_ForcedRows        As Integer = 32 ' Remove forced rows

' Calculation result state (negative - unsuccessful, positive - successful)}
  Const calc_None           As Integer = 0  ' Calculation has not been provided yet
  Const calc_Optimal        As Integer = 1  ' Finished with optimal solution
  Const calc_Infeasible     As Integer = -1 ' Failed with primal infeasibility
  Const calc_DblInfeasible  As Integer = -2 ' Failed with dual infeasibility
  Const calc_Unknown        As Integer = 2  ' Finished because reached the max. of iterations
  Const calc_Suboptimal     As Integer = 3  ' Finished due to slow convergence
  Const calc_Stoped         As Integer = 4  ' Stoped by the user
  Const calc_Error          As Integer = -3 ' Failed due to numerical eror
  Const calc_Unbounded      As Integer = -4 ' Failed because the linear program is unbounded

' Flags returned by the user-defined callback function
  Const res_Abort As Integer = -1  ' Calculation is canceled
  Const res_None   As Integer = 0  ' Calculation continues
  Const res_Stop   As Integer = 1  ' Calculation is stoped and the results are ready

' The user-defined callback function must have the following format:
'
' Function CallBack(ByVal IterCount  As Integer, ' Current iteration
'                   ByVal PrimalObj  As Double,  ' Primal objective function
'                   ByVal DualObj    As Double,  ' Dual objective function
'                   ByVal InfPrimal  As Double,  ' Primal infeasibility
'                   ByVal InfDual    As Double,  ' Dual infeasibility
'                   ByVal Optimality As Double   ' Optimality
'                   ) As Integer
'


' Set number of conastraints (rows)
Private Declare Sub SetConstraintCount Lib "gipals32.dll" Alias "SetConstraintCount@4" (ByVal ACount As Integer)

' Set number of decision (primal) variables
Private Declare Sub SetVariableCount Lib "gipals32.dll" Alias "SetVariableCount@4" (ByVal ACount As Integer)

' Returns number of constraints
Private Declare Function GetConstraintCount Lib "gipals32.dll" Alias "GetConstraintCount@0" () As Integer

' Returns number of decision (primal) variables
Private Declare Function GetVariableCount Lib "gipals32.dll" Alias "GetVariableCount@0" () As Integer

' Clears the linear program. Deletes all existing data and set number of
' constraints and variables to 1
Private Declare Sub ClearLinearProgram Lib "gipals32.dll" Alias "ClearLinearProgram@0" ()

' Set the objective to minimize (1) or maximize (0)
Private Declare Sub SetObjectiveType Lib "gipals32.dll" Alias "SetObjectiveType@4" (ByVal Minimization As Integer)

' Set the cost and bounds for the variable Index. Returns 0 if variable does not exist.
'  Index    As Integer - Variable index
'  Cost     As Double  - Objective function coefficient
'  Lower    As Double  - Lower bound of variable (ignored if LowerInf <> 0)
'  Upper    As Double  - Upper bound of variable (ignored if UpperInf <> 0)
'  LowerInf As Integer - If <> 0 then indicates variable has no lower bound
'  UpperInf As Integer - If <> 0 then indicates variable has no upper bound
Private Declare Function SetVariable Lib "gipals32.dll" Alias "SetVariable@36" (ByVal Index As Integer, ByVal Cost As Double, ByVal Lower As Double, ByVal Upper As Double, ByVal LowerInf As Integer, ByVal UpperInf As Integer) As Integer

' Add a new variable and set the cost and bounds for the variable Index.
' Returns a new variable index if succeeded and -1 if the maximum size reached.
'   Cost     As Double  - Objective function coefficient
'   Lower    As Double  - Lower bound of variable (ignored if LowerInf <> 0)
'   Upper    As Double  - Upper bound of variable (ignored if UpperInf <> 0)
'   LowerInf As Integer - If <> 0 then indicates variable has no lower bound
'   UpperInf As Integer - If <> 0 then indicates variable has no upper bound
Private Declare Function AddVariable Lib "gipals32.dll" Alias "AddVariable@32" (ByVal Cost As Double, ByVal Lower As Double, ByVal Upper As Double, ByVal LowerInf As Integer, ByVal UpperInf As Integer) As Integer

' Set the right side and the sign of the specified constraint Index.
' Returns 0 if constraint does not exist.
'   Index As Integer - Index of the constraint
'   Right As Double  - Right side of the constraint
'   Sign  As Integer - Sign (sign_Less, sign_Equal, sign_More)
Private Declare Function SetConstraint Lib "gipals32.dll" Alias "SetConstraint@16" (ByVal Index As Integer, ByVal Right As Double, ByVal Sign As Integer) As Integer

' Add a new constraint and set its right side and the sign.
' Returns index of the constraint or -1 if the maximum size reached.
'   Right As Double  - Right side of the constraint
'   Sign  As Integer - Sign (sign_Less, sign_Equal, sign_More)
Private Declare Function AddConstraint Lib "gipals32.dll" Alias "AddConstraint@12" (ByVal Right As Double, ByVal Sign As Integer) As Integer

' Set the coefficient for the specified variable VarIndex in the specified
' constraint RowIndex. Returns 1 if succeeded.
'   RowIndex As Integer - constraint index
'   VarIndex As Integer - variable index
'   Value    As Double  - coefficient value
Private Declare Function SetConstraintElement Lib "gipals32.dll" Alias "SetConstraintElement@16" (ByVal RowIndex As Integer, ByVal VarIndex As Integer, ByVal Value As Double) As Integer

' The following two routines allow to fill the constraint matrix directly
' with much higher speed than SetConstraintElement function

' Selects the constraints to fill. Returns 0 if the constraints does not exist
Private Declare Function DirectSelectConstraint Lib "gipals32.dll" Alias "DirectSelectConstraint@4" (ByVal Index As Integer) As Integer

' Add a new constraint element in fast way. Variable index MUST be in an
' ascending order. Returns 1 if succeeded.
'   Index As Integer  - variable index
'   Value As Double   - variable coefficient
Private Declare Function DirectAddConstraintElement Lib "gipals32.dll" Alias "DirectAddConstraintElement@12" (ByVal Index As Integer, ByVal Value As Double) As Integer

' Load Linear program from the specified file in MPS format.
' Returns: 1 if succeeded.
'           0 if the maximum allowed number of variables or constraint reached
'          -1 if the file is in wrong format
Private Declare Function LoadFromMPS Lib "gipals32.dll" Alias "LoadFromMPS@4" (ByVal AFile As String) As Integer

' The main function. Calculates the linear program and returns result.
'   The result is defined in "Calculation result" section above.
'   ProcessFunc is callbac function provided to control iteration and cancel
'   or stop the calculation
Private Declare Function Calculate Lib "gipals32.dll" Alias "Calculate@4" (ByVal ProcessFunc As Integer) As Integer

' GET RESULTS
' Returns primal objective function value
Private Declare Function PrimalObjective Lib "gipals32.dll" Alias "PrimalObjective@0" () As Double

' Returns dual objective function value
Private Declare Function DualObjective Lib "gipals32.dll" Alias "DualObjective@0" () As Double

' Returns value of the specified decision (primal) variable (X)
Private Declare Function PrimalValue Lib "gipals32.dll" Alias "PrimalValue@4" (ByVal Index As Integer) As Double

' Returns value of the specified dual variable (Y)
Private Declare Function DualValue Lib "gipals32.dll" Alias "DualValue@4" (ByVal Index As Integer) As Double

' Returns value of the specified reduced cost variable (S)
Private Declare Function ReducedCostValue Lib "gipals32.dll" Alias "ReducedCostValue@4" (ByVal Index As Integer) As Double


'///////////////////////////////////////////////////////////////////////////////////////////
' The following routines are optional and should be used to tune the calculation engine.  //
'///////////////////////////////////////////////////////////////////////////////////////////

' Flags are combination of Preprocessor flags or prep_Disable to disable
Private Declare Sub SetPreprocessor Lib "gipals32.dll" Alias "SetPreprocessor@4" (ByVal Flags As Integer)

' Set tolerances. Defaults are: Primal=1e-8, Dual=1e-8, Optimal=1e-10
Private Declare Sub SetTolerances Lib "gipals32.dll" Alias "SetTolerances@24" (ByVal Primal As Double, ByVal Dual As Double, ByVal Optimal As Double)

' Set maximum of iterations (default is 100)
Private Declare Sub SetMaxIterationCount Lib "gipals32.dll" Alias "SetMaxIterationCount@4" (ByVal Value As Integer)

' Enable/Disable the LP scaling. 1 - enable (default), 0 - disable.
Private Declare Sub SetScaling Lib "gipals32.dll" Alias "SetScaling@4" (ByVal Value As Integer)

' Enable/Disable the iterative refinement. 1 - enable (default), 0 - disable.
Private Declare Sub SetRefinement Lib "gipals32.dll" Alias "SetRefinement@4" (ByVal Value As Integer)

' Use the Gondzio correction. 1 - use (default), 0 - don't.
Private Declare Sub SetGondzio Lib "gipals32.dll" Alias "SetGondzio@4" (ByVal Value As Integer)

Private Function FmtNumber(ByVal Value As String, ByVal Length As Integer) As String
  FmtNumber = Value
  Dim Len1 As Integer
  Len1 = Length - Len(Value)
  For Iter = 1 To Len1
    FmtNumber = " " + FmtNumber
  Next Iter
End Function


Private Sub btnLoadMPS_Click()
  LoadFromMPS (lstFile.Path + "\" + lstFile.FileName)
  Screen.MousePointer = MousePointerConstants.vbHourglass
  Calculate (0)
' Output results
  lbResults.Clear
  lbResults.AddItem ("  No. |      Primal Value (X) |      Reduced Cost (S) ")
  lbResults.AddItem ("------------------------------------------------------")
  For Iter = 0 To GetVariableCount - 1
    lbResults.AddItem (FmtNumber(Format(Iter, d), 5) + " | " + FmtNumber(Format(PrimalValue(Iter), g), 21) + " | " + FmtNumber(Format(DualValue(Iter), g), 21))
  Next Iter
      
  Screen.MousePointer = MousePointerConstants.vbDefault
  edtPrimalObj.Text = PrimalObjective
  edtDualObj.Text = DualObjective
End Sub

Private Sub FillVariables()
  Dim Tmp As Integer
  Tmp = AddVariable(15, 0, 0, 0, 1) ' Tons from Detroit to Boston. Cost per tone is $15
  Tmp = AddVariable(20, 0, 0, 0, 1) ' Tons from Detroit to New York. Cost per tone is $20
  Tmp = AddVariable(16, 0, 0, 0, 1) ' Tons from Detroit to Chicago. Cost per tone is $16
  Tmp = AddVariable(21, 0, 0, 0, 1) ' Tons from Detroit to Indianapolis. Cost per tone is $21
  Tmp = AddVariable(25, 0, 0, 0, 1) ' Tons from Pittsburgh to Boston. Cost per tone is $25
  Tmp = AddVariable(13, 0, 0, 0, 1) ' Tons from Pittsburgh to New York. Cost per tone is $13
  Tmp = AddVariable(5, 0, 0, 0, 1)  ' Tons from Pittsburgh to Chicago. Cost per tone is $5
  Tmp = AddVariable(11, 0, 0, 0, 1) ' Tons from Pittsburgh to Indianapolis. Cost per tone is $11
  Tmp = AddVariable(15, 0, 0, 0, 1) ' Tons from Buffalo to Boston. Cost per tone is $15
  Tmp = AddVariable(15, 0, 0, 0, 1) ' Tons from Buffalo to New York. Cost per tone is $15
  Tmp = AddVariable(7, 0, 0, 0, 1)  ' Tons from Buffalo to Chicago. Cost per tone is $7
  Tmp = AddVariable(17, 0, 0, 0, 1) ' Tons from Buffalo to Indianapolis.Cost per tone is $17
End Sub

Private Sub FillConstraints()
  Dim Tmp As Integer
  Tmp = AddConstraint(250, sign_Less)  ' Transported from Detroit must be less then 250 tones.
  Tmp = AddConstraint(130, sign_Less)  ' Transported from Pittsburgh must be less then 130.
  Tmp = AddConstraint(235, sign_Less)  ' Transported from Buffalo must be less then 235.
  Tmp = AddConstraint(75, sign_Equal)  ' Shipped to Boston must be 75 tones.
  Tmp = AddConstraint(230, sign_Equal) ' Shipped to New York must be 230 tones.
  Tmp = AddConstraint(240, sign_Equal) ' Shipped to Chicago must be 240 tones.
  Tmp = AddConstraint(70, sign_Equal)  ' Shipped to Indianapolis must be 70 tones.
End Sub

Private Sub FillMatrix()
  Dim Tmp As Integer
'   X_DT_BS + X_DT_NY + X_DT_CH + X_DT_IN <= 250
  Tmp = DirectSelectConstraint(0)
  Tmp = DirectAddConstraintElement(0, 1) ' X_DT_BS
  Tmp = DirectAddConstraintElement(1, 1) ' X_DT_NY
  Tmp = DirectAddConstraintElement(2, 1) ' X_DT_CH
  Tmp = DirectAddConstraintElement(3, 1) ' X_DT_IN

'   X_PT_BS + X_PT_NY + X_PT_CH + X_PT_IN <= 130
  Tmp = DirectSelectConstraint(1)
  Tmp = DirectAddConstraintElement(4, 1) ' X_PT_BS
  Tmp = DirectAddConstraintElement(5, 1) ' X_PT_NY
  Tmp = DirectAddConstraintElement(6, 1) ' X_PT_CH
  Tmp = DirectAddConstraintElement(7, 1) ' X_PT_IN

'   X_BF_BS + X_BF_NY + X_BF_CH + X_BF_IN <= 235
  Tmp = DirectSelectConstraint(2)
  Tmp = DirectAddConstraintElement(8, 1)  ' X_BF_BS
  Tmp = DirectAddConstraintElement(9, 1)  ' X_BF_NY
  Tmp = DirectAddConstraintElement(10, 1) ' X_BF_CH
  Tmp = DirectAddConstraintElement(11, 1) ' X_BF_IN

'   X_DT_BS + X_PT_BS + X_BF_BS = 75
  Tmp = DirectSelectConstraint(3)
  Tmp = DirectAddConstraintElement(0, 1) ' X_DT_BS
  Tmp = DirectAddConstraintElement(4, 1) ' X_PT_BS
  Tmp = DirectAddConstraintElement(8, 1) ' X_BF_BS

'   X_DT_NY + X_PT_NY + X_BF_NY = 230
  Tmp = DirectSelectConstraint(4)
  Tmp = DirectAddConstraintElement(1, 1) ' X_DT_NY
  Tmp = DirectAddConstraintElement(5, 1) ' X_PT_NY
  Tmp = DirectAddConstraintElement(9, 1) ' X_BF_NY

'   X_DT_CH + X_PT_CH + X_BF_CH = 240
  Tmp = DirectSelectConstraint(5)
  Tmp = DirectAddConstraintElement(2, 1)  ' X_DT_CH
  Tmp = DirectAddConstraintElement(6, 1)  ' X_PT_CH
  Tmp = DirectAddConstraintElement(10, 1) ' X_BF_CH

'   X_DT_IN + X_PT_IN + X_BF_IN = 70
  Tmp = DirectSelectConstraint(6)
  Tmp = DirectAddConstraintElement(3, 1)  ' X_DT_IN
  Tmp = DirectAddConstraintElement(7, 1)  ' X_PT_IN
  Tmp = DirectAddConstraintElement(11, 1) ' X_BF_IN
End Sub


Private Sub btnTransport_Click()

'  This is an example of a transport problem (Minimal Cost).
'
'  There are three warehouses at different cities: Detroit, Pittsburgh and Buffalo.
'  They have 250, 130 and 235 tons of paper accordingly. There are four publishers in
'  Boston, New York, Chicago and Indianapolis. They ordered 75, 230, 240 and 70 tons of
'  paper to publish new books.
'  There are the following costs in dollars of transportation of one ton of paper:
'
'  From \ To Boston (BS) New York (NY)   Chicago (CH)    Indianapolis (IN)
'  Detroit (DT)           15                20             16                   21
'  Pittsburgh (PT)        25                13              5                   11
'  Buffalo (BF)           15                15              7                   17
'
'  We denote the cost of transportation from one city to another by C_ prefix, for example
'  cost from Buffalo to Chicago is C_BF_CH.
'
'  We have to find a plan that all orders will be performed and the transportation costs
'  will be minimized. The decision variables are amounts of tons transported from one
'  city to another denoted by prefix X_:
'
'  X_DT_BS = tons from Detroit to Boston,
'  X_PT_BS = tons from Pittsburgh to Boston,
'  X_BF_NY = tons from Buffalo to New York and etc.
'
'  The objective function is sum of multiplications of transported tons and their costs:
'  F = C_DT_BS * X_DT_BS + C_DT_NY * C_DT_NY + C_DT_CH * C_DT_CH + 
'
'  The constraints are defined in terms of the transported paper amount from one
'  warehouse or to one publisher.
'
'  For example:
'  Amount transported from Detroit cannot be more than 250 tons:
'  X_DT_BS X_DT_NY + X_DT_CH + X_DT_IN <= 250
  FillVariables
  FillConstraints
  FillMatrix
  Calculate (0)
' Output results
  lbResults.Clear
  lbResults.AddItem ("The Total Cost of Transportation is $" + Format(PrimalObjective, "#####0.00"))
  lbResults.AddItem ("")
  lbResults.AddItem ("Shipment plan:")
  lbResults.AddItem ("")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(0), "#####0.00"), 10) + " Tons from Detroit to Boston")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(1), "#####0.00"), 10) + " Tons from Detroit to New York")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(2), "#####0.00"), 10) + " Tons from Detroit to Chicago")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(3), "#####0.00"), 10) + " Tons from Detroit to Indianapolis")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(4), "#####0.00"), 10) + " Tons from Pittsburgh to Boston")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(5), "#####0.00"), 10) + " Tons from Pittsburgh to New York")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(6), "#####0.00"), 10) + " Tons from Pittsburgh to Chicago")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(7), "#####0.00"), 10) + " Tons from Pittsburgh to Indianapolis")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(8), "#####0.00"), 10) + " Tons from Buffalo to Boston")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(9), "#####0.00"), 10) + " Tons from Buffalo to New York")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(10), "#####0.00"), 10) + " Tons from Buffalo to Chicago")
  lbResults.AddItem (FmtNumber(Format(PrimalValue(11), "#####0.00"), 10) + " Tons from Buffalo to Indianapolis")
     
  edtPrimalObj.Text = PrimalObjective
  edtDualObj.Text = DualObjective

End Sub

Private Sub cmbDrive_Change()
  lstDir.Path = cmbDrive.Drive
End Sub

Private Sub lstDir_Change()
  lstFile.Path = lstDir
End Sub
